package com.proximity.demo.eventbriteApi.Categories;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.proximity.demo.eventbriteApi.Events.Event;
import com.proximity.demo.eventbriteApi.Subcategories.Subcategory;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;

@Entity
@JsonIgnoreProperties(ignoreUnknown = true)
@Table(name="CATEGORY")
public class Category {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int categoryid;

    @Column(unique = true)
    private int id;
    private String name;
    private String short_name;

    public Category() { }

    @ManyToMany(mappedBy = "category", fetch = FetchType.EAGER)
    private Set<Event> events = new HashSet<>();

    @OneToMany(mappedBy = "subToCategory", fetch = FetchType.EAGER)
    private Set<Subcategory> subcategories = new HashSet<>();

    public Category(int id, String name, String short_name, Set<Event> events, Set<Subcategory> subcategories) {
        this.id = id;
        this.name = name;
        this.short_name = short_name;
        this.events = events;
        this.subcategories = subcategories;
    }

    public int getCategoryid() {
        return categoryid;
    }

    public void setCategoryid(int categoryid) {
        this.categoryid = categoryid;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getShort_name() {
        return short_name;
    }

    public void setShort_name(String short_name) {
        this.short_name = short_name;
    }

    public Set<Event> getEvents() {
        return events;
    }

    public void setEvents(Set<Event> events) {
        this.events = events;
    }

    public Set<Subcategory> getSubcategories() {
        return subcategories;
    }

    public void setSubcategories(Set<Subcategory> subcategories) {
        this.subcategories = subcategories;
    }

    @Override
    public String toString() {
        return "Category{" +
                "categoryid=" + categoryid +
                ", id=" + id +
                ", name='" + name + '\'' +
                ", short_name='" + short_name + '\'' +
                ", events=" + events +
                ", subcategories=" + subcategories +
                '}';
    }
}
