package com.proximity.demo.eventbriteApi.Subcategories;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.proximity.demo.eventbriteApi.Categories.Category;
import com.proximity.demo.eventbriteApi.Events.Event;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

@Entity
@JsonIgnoreProperties(ignoreUnknown = true)
@Table(name="SUBCATEGORY")
public class Subcategory {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int subcategoryid;

    @Column(unique = true)
    private int id;
    private String name;
    private int parent_id;

    public Subcategory() {}

    public Subcategory(int id, String name, int parent_id, Category subToCategory, Set<Event> event) {
        this.id = id;
        this.name = name;
        this.parent_id = parent_id;
        this.subToCategory = subToCategory;
        this.event = event;
    }

    @JsonProperty("parent_category")
    private void unpackParentCategory(Map<String, Object> parent_category) {
        this.parent_id = Integer.valueOf((String)parent_category.get("id"));
    }

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "category_id")
    @JsonIgnore
    private Category subToCategory;

    @ManyToMany(mappedBy = "subcategory")
    private Set<Event> event = new HashSet<>();

    public int getSubcategoryid() {
        return subcategoryid;
    }

    public void setSubcategoryid(int subcategoryid) {
        this.subcategoryid = subcategoryid;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getParent_id() {
        return parent_id;
    }

    public void setParent_id(int parent_id) {
        this.parent_id = parent_id;
    }

    public Category getSubToCategory() {
        return subToCategory;
    }

    public void setSubToCategory(Category subToCategory) {
        this.subToCategory = subToCategory;
    }

    public Set<Event> getEvent() {
        return event;
    }

    public void setEvent(Set<Event> event) {
        this.event = event;
    }

    @Override
    public String toString() {
        return "Subcategory{" +
                "subcategoryid=" + subcategoryid +
                ", id=" + id +
                ", name='" + name + '\'' +
                ", parent_id=" + parent_id +
                ", subToCategory=" + subToCategory +
                ", event=" + event +
                '}';
    }
}
